<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="原因编码" prop="revisionCode">
              <el-input v-model="queryParams.revisionCode" placeholder="请输入原因编码" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="原因描述" prop="revisionDesc">
              <el-input v-model="queryParams.revisionDesc" placeholder="请输入原因描述" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['qms:revisionInfo:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['qms:revisionInfo:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['qms:revisionInfo:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['qms:revisionInfo:export']">导出</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" :columns="columns" :search="true" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="revisionInfoList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="原因编码" align="center" prop="revisionCode" v-if="columns[2].visible"/>
        <el-table-column label="原因描述" align="center" prop="revisionDesc" v-if="columns[3].visible"/>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['qms:revisionInfo:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['qms:revisionInfo:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改改判原因信息对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="revisionInfoFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="原因编码" prop="revisionCode">
          <el-input v-model="form.revisionCode" placeholder="请输入原因编码" />
        </el-form-item>
        <el-form-item label="原因描述" prop="revisionDesc">
          <el-input v-model="form.revisionDesc" placeholder="请输入原因描述" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="RevisionInfo" lang="ts">
import { listRevisionInfo, getRevisionInfo, delRevisionInfo, addRevisionInfo, updateRevisionInfo } from '@/api/qms/revisionInfo';
import { RevisionInfoVO, RevisionInfoQuery, RevisionInfoForm } from '@/api/qms/revisionInfo/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const revisionInfoList = ref<RevisionInfoVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const revisionInfoFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

// 列显隐信息
const columns = ref<FieldOption[]>([
        { key: 0, label: `主键标识`, visible: true },
        { key: 1, label: `租户号`, visible: true },
        { key: 2, label: `原因编码`, visible: true },
        { key: 3, label: `原因描述`, visible: true },
        { key: 4, label: `预留字段`, visible: true },
        { key: 5, label: `预留字段`, visible: true },
        { key: 6, label: `预留字段`, visible: true },
        { key: 7, label: `预留字段`, visible: true },
        { key: 8, label: `创建部门`, visible: true },
        { key: 9, label: `创建人`, visible: true },
        { key: 10, label: `创建时间`, visible: true },
        { key: 11, label: `更新人`, visible: true },
        { key: 12, label: `更新时间`, visible: true },
]);

const initFormData: RevisionInfoForm = {
  revisionCode: undefined,
  revisionDesc: undefined,
}
const data = reactive<PageData<RevisionInfoForm, RevisionInfoQuery>>({
  form: {...initFormData},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    revisionCode: undefined,
    revisionDesc: undefined,
    params: {
    }
  },
  rules: {
    revisionCode: [
      { required: true, message: "原因编码不能为空", trigger: "blur" }
    ],
    revisionDesc: [
      { required: true, message: "原因描述不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询改判原因信息列表 */
const getList = async () => {
  loading.value = true;
  const res = await listRevisionInfo(queryParams.value);
  revisionInfoList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = {...initFormData};
  revisionInfoFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: RevisionInfoVO[]) => {
  ids.value = selection.map(item => item.revisionId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = "添加改判原因信息";
}

/** 修改按钮操作 */
const handleUpdate = async (row?: RevisionInfoVO) => {
  reset();
  const _revisionId = row?.revisionId || ids.value[0]
  const res = await getRevisionInfo(_revisionId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = "修改改判原因信息";
}

/** 提交按钮 */
const submitForm = () => {
  revisionInfoFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.revisionId) {
        await updateRevisionInfo(form.value).finally(() =>  buttonLoading.value = false);
      } else {
        await addRevisionInfo(form.value).finally(() =>  buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: RevisionInfoVO) => {
  const _revisionIds = row?.revisionId || ids.value;
  await proxy?.$modal.confirm('是否确认删除改判原因信息编号为"' + _revisionIds + '"的数据项？').finally(() => loading.value = false);
  await delRevisionInfo(_revisionIds);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('qms/revisionInfo/export', {
    ...queryParams.value
  }, `revisionInfo_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
